/*
 * app配置文件、常量
 * */

!function (window) {
    var ua = window.navigator.userAgent.toLowerCase(),
        reg = /msie|applewebkit.+safari/;
    if (reg.test(ua)) {
        var _sort = Array.prototype.sort;
        Array.prototype.sort = function (fn) {
            if (!!fn && typeof fn === 'function') {
                if (this.length < 2) return this;
                var i = 0, j = i + 1, l = this.length, tmp, r = false, t = 0;
                for (; i < l; i++) {
                    for (j = i + 1; j < l; j++) {
                        t = fn.call(this, this[i], this[j]);
                        r = (typeof t === 'number' ? t :
                            !!t ? 1 : 0) > 0
                            ? true : false;
                        if (r) {
                            tmp = this[i];
                            this[i] = this[j];
                            this[j] = tmp;
                        }
                    }
                }
                return this;
            } else {
                return _sort.call(this);
            }
        };
    }
}(window);

(function (g) {
    var app = g.app = {};

    var base = app.baseURI = "http://182.92.149.250:8080";
        var userBase = "http://user.cninfo.com.cn/jcapp";
        var otherBase = "http://mobile.cninfo.com.cn/jcapp";
    app.url = {
        //登录
        login: userBase + "/usersys/reg/login.htm",
        //登出
        loginOut: userBase + "/usersys/reg/logout.htm",
        //注册
        userReg: userBase + "/usersys/reg/newUserReg.htm",
        //找回密码
        toFindPwd: userBase + "/usersys/reg/toFindPwd.htm",
        //短信验证码验证
        verifyCode: userBase + "/usersys/reg/verifyCode.htm",
        //短信验证码验证
        recoverPassword: userBase + "/usersys/reg/recoverPassword.htm",
        //重新获取验证码
        reSendCode: userBase + "/usersys/reg/reSendCode.htm",
        //修改密码
        modifyPwd: userBase + "/usersys/reg/modifyPwd.htm",
        //添加自选股
        addMyStock: userBase + "/usersys/stock/addReg.htm",
        //删除自选股
        delMyStock: userBase + "/usersys/stock/delReg.htm",
        //获取自选股
        getMyStock: userBase + "/usersys/stock/getMyStock.htm",
        //搜索keyword、ageNo=1、pageSize=20
        searchStock: otherBase+ "/search.json",
        //根据股票Code获取股票信息
        stockInfo: otherBase+ "/notice/getPlate.json",
        //新股日历
        xgrl: otherBase+ "/hintipo/ipo/fxrl",
        //新股日历
        ipoDate: otherBase+ "/hintipo/ipo/ipoDate",
        //发行概况
        fxgk: otherBase+ "/hintipo/ipo/fxgk",
        //提示
        hint: otherBase+ "/hintipo/hint/home",
        //公告http://182.92.149.250:8080/notice/selfStock.json
        notice: otherBase+ "/notice/list.json",
        //公告自选股过滤接口
        selfNotice: otherBase+ "/notice/selfStock.json",

        noticeDetail: otherBase+ "/notice/classifyDetail.json",
        //点赞
        dianZan: userBase + "/usersys/notice/reg.htm"
    };

    app.networkState = function () {
        var connectStatus = localStorage["connectStatus"];
        if (connectStatus && connectStatus == -1) {
            $alert("无法连接，请您检查网络");
            return false
        }
        return true;
    };

    app.dianZan = function (noticeId, n, stockType, func) {
        if (!app.networkState()) {
            return
        }
        //?userAddr=9&regType=1&type=0&noticeId=1
        var userAddr = app.IMEI || 9;
        var regType = 0;
        var user = app.getUser();
        if (user && user.statusCode) {
            userAddr = user.statusCode;
            regType = 1;
        }
        var url = app.url.dianZan + "?userAddr=" + userAddr + "&regType=" + regType + "&noticeId=" + noticeId + "&type=" + n + "&stockType=" + stockType;
        $.getJSON(url, function (data) {
            func(data);
        }, 'json', getJSONError, 'GET', "", false);
    };

    app.IMEI = localStorage["IMEI"];

    var cache = app.cache = {

    };

    app.getUser = function () {
        var userStr = localStorage["user"];
        return(userStr ? JSON.parse(userStr) : null);
    };

    cache.user = app.getUser();

    app.myStockCodeArray = [];
    //仅获取数据库中的自选股
    app.getStorageMyStock = function (myStock) {
        myStock = (myStock && myStock != "undefined") ? myStock : localStorage["myStock"];
        var stocks = myStock ? JSON.parse(myStock) : [];
        if (stocks.length > 0) {
            for (var i = 0, l = stocks.length; i < l; i += 1) {
                app.myStockCodeArray.push(stocks[i].code);
            }
        }
        cache.myStock = stocks;
        return stocks;
    };
    app.getStorageMyStock();

    app.stockShowType = localStorage["stockShowType"] || 'false';
//    app.setStockShowType = function (type) {
//        app.stockShowType = localStorage["stockShowType"] = type;
//    };

    /*
     * 注册
     * */
    app.regUser = function (mobileNo, password, func) {
        if (!app.networkState()) {
            return
        }
        var url = app.url.userReg + "?mobileNo=" + mobileNo + "&password=" + password;
        $.getJSON(url, function (data) {
            func(data);
        }, 'json', getJSONError, 'GET', "", false);
    };
    app.verifyCode = function (statusCode, verifyCode, func) {
        if (!app.networkState()) {
            return
        }
        var url = app.url.verifyCode + "?statusCode=" + statusCode + "&verifyCode=" + verifyCode;
        $.getJSON(url, function (data) {
            func(data);
        }, 'json', getJSONError, 'GET', "", false);
    };


    /*
     * 找回密码
     * */
    app.toFindPwd = function (mobileNo, func) {
        if (!app.networkState()) {
            return
        }
        var url = app.url.toFindPwd + "?mobileNo=" + mobileNo;
        $.getJSON(url, function (data) {
            func(data);
        }, 'json', getJSONError, 'GET', "", false);
    };
    app.recoverPassword = function (statusCode, password, func) {
        if (!app.networkState()) {
            return
        }
        var url = app.url.recoverPassword + "?statusCode=" + statusCode + "&password=" + password;
        $.getJSON(url, function (data) {
            func(data);
        }, 'json', getJSONError, 'GET', "", false);
    };

    /*
     * 修改密码
     * */
    app.modifyPwd = function (username, password, newPassword, func) {
        if (!app.networkState()) {
            return
        }
        var url = app.url.modifyPwd + "?username=" + username + "&password=" + password + "&newPassword=" + newPassword;
        $.getJSON(url, function (data) {
            func(data);
        }, 'json', getJSONError, 'GET', "", false);
    };

    /*
     * 重新获取验证码?statusCode=31
     * */
    app.reSendCode = function (statusCode, func) {
        if (!app.networkState()) {
            return
        }
        var url = app.url.reSendCode + "?statusCode=" + statusCode;
        $.getJSON(url, function (data) {
            func(data);
        }, 'json', getJSONError, 'GET', "", false);
    };


    /*
     *获取自选股
     * */
    app.getMyStock = function (func, isRemote) {
        var user = app.getUser();
        if (user && user.statusCode && isRemote) {
            if (!app.networkState()) {
                return
            }
            var url = app.url.getMyStock + "?statusCode=" + user.statusCode;
            $.getJSON(url, function (data) {
                if (data.success) {
                    var arr = [];
                    for(var i = 0, l = data.data.length;i<l;i+=1){
                        var n = data.data[i];
                        n.name = decodeURI(n.name);
                        arr.push(n)
                    }
                    cache.myStock = arr;
                    localStorage["myStock"] = JSON.stringify(cache.myStock);
                    func(data.data);
                }
            }, 'json', getJSONError, 'GET', "", false);
        } else {
            func(app.getLocalStock());
        }
    };
    /*
     *根绝股票code获取详情
     * */
    app.stockInfo = function (code, func) {
        if (!app.networkState()) {
            return
        }
        var url = app.url.stockInfo + "?code=" + code;
        $.getJSON(url, function (data) {
            func(data);
        }, 'json', getJSONError, 'GET', "", false);
    };

    /*
     *添加自选股
     * */
    app.addMyStock = function (code, func, name) {
        var ids = app.getLocalStockIds();
        //index = -2;//ids.indexOf(code);
        for (var i = 0, l = ids.length; i < l; i += 1) {
            //index = ids[i];
            if (ids[i] == code && localStockNames[i] === name) {
                $alert("自选股中已存在");
                return;
            }
        }
//        if (app.getLocalStockIds().indexOf(code) > -1) {
//            $alert("自选股中已存在");
//            return;
//        }
        var user = app.getUser();
        name = name || "";
        if (user && user.statusCode) {
            if (!app.networkState()) {
                return
            }
            var url = app.url.addMyStock + "?statusCode=" + user.statusCode + "&codes=" + code + (name ? ("&names=" + name) : "");
            $.getJSON(url, function (data) {
                if (data.success) {
                    app.getMyStock(func, true);
                } else {
                    $alert(data.info);
                }
            }, 'json', getJSONError, 'GET', "", false);
        } else {
            localStockArray.push({code: code, name: name});
            localStorage["myStock"] = JSON.stringify(localStockArray);
            func(localStockArray);
        }
//        else {
//            func({success: false});
//        }
    };

    app.getLocalStock = function () {
        var stock = localStorage["myStock"];
        return stock ? JSON.parse(stock) : [];
    };

    var localStockNames = app.localStockNames = [];
    var localStockArray = app.localStockArray = [];
    app.getLocalStockIds = function () {
        var stock = localStorage["myStock"];
        var ids = [];
        localStockNames = [];
        localStockArray = stock = stock ? JSON.parse(stock) : [];
        if (stock.length > 0) {
            for (var i = 0, l = stock.length; i < l; i += 1) {
                ids.push(stock[i].code);
                localStockNames.push(stock[i].name);
            }
        }
        return ids;
    };

    /*
     *删除自选股
     * */
    app.delMyStock = function (codes, func, names) {
        if ($.isArray(codes) && codes.length > 0) {

            var user = app.getUser();
            if (user && user.statusCode) {
                if (!app.networkState()) {
                    return
                }
                if ($.isArray(names) && names.length === codes.length) {
                    names = names.join(",");
                }
                var url = app.url.delMyStock + "?statusCode=" + user.statusCode + "&codes=" + codes.join(",") + (names ? ("&names=" + names) : "");
                $.getJSON(url, function (data) {
                    //func(data);
                    if (data.success) {
                        app.getMyStock(func, true);
                    }
                }, 'json', getJSONError, 'GET', "", false);
            } else {
                var stocks = app.getLocalStock(),
                    i = 0, l = codes.length;
                for (; i < l; i += 1) {
                    delLocalMyStock(codes[i], names[i], stocks);
                }
                localStorage["myStock"] = JSON.stringify(stocks);
                func(stocks);
            }
        }
    };
    
    function delLocalMyStock (code, name, myStocks) {
      var i = 0, l = myStocks.length;
      for(;i < l; i+=1){
          if(myStocks[i].code === code && myStocks[i].name === name){
              myStocks.splice(i, 1);
              return
          }
      }
    }

    /*
     *检查是否已经是自选股
     * */
    app.checkMyStock = function (code) {
        var ids = app.getLocalStockIds();
//        for (var i = 0, l = stocks.length, n = null; i < l; i += 1) {
//            n = stocks[i];
//            if (n.code == code) {
//                return true;
//            }
//        }
        return ids.indexOf(code) > -1;
    };

    /*
     *搜索股票
     * */
    app.searchStock = function (keyword, func) {
        if (!app.networkState()) {
            return
        }
        var url = app.url.searchStock + "?pageNo=1&pageSize=20&keyword=" + keyword;
        $.getJSON(url, function (data) {
            func(data);
        }, 'json', getJSONError, 'GET', "", false);
    };

    /*
     *新股日历
     * */
    app.getXgrl = function (dateStr, func) {
        if (!app.networkState()) {
            return
        }
        var url = app.url.xgrl + "?date=" + dateStr;
        $.getJSON(url, function (data) {
            func(data);
        }, 'json', getJSONError, 'GET', "", false);
    };
    /*
     *获取新股日历日期更新
     * */
    app.ipoDate = function (dateArr, func) {
        if (!app.networkState()) {
            return
        }
        var url = app.url.ipoDate + "?date=" + dateArr.join(",");
        $.getJSON(url, function (data) {
            func(data);
        }, 'json', getJSONError, 'GET', "", false);
    };

    /*
     *发行概况
     * */
    app.getFxgk = function (func) {
        if (!app.networkState()) {
            return
        }
        $.getJSON(app.url.fxgk, function (data) {
            func(data);
        }, 'json', getJSONError, 'GET', "", false);
    };


    /*
     *提示字段对照表
     * */
    app.hintKv = {
        "停复牌信息": ["tfpxx", 1],
        "重大事项停牌日期": ["zdsxtprq", 2],
        "重大事项复牌日期": ["zdsxfprq", 2],
        "网络投票开始日": ["wltpksr", 2],
        "网络投票结束日": ["wltpjsr", 2],
        "分红转增股权登记日": ["fhzzgqdjr", 2],
        "股东资格登记日": ["gdzgdjr", 2],
        "增发新股上市日": ["zfxgssr", 3],
        "分红转增除权除息日": ["fhzzcqcxr", 2],
        "分红转增股份上市日": ["fhzzgfssr", 2],
        "分红转增红利发放日": ["fhzzhlffr", 2],
        "股东大会召开日": ["gddhzkr", 2],
        "撤销特别处理日": ["cxtbclr", 2],
        "债券上市日": ["zqssr", 2],
        "债券付息日": ["zqfxr", 2],
        "债券除息日": ["zqcxr", 2],
        "基金发行开始日": ["jjfxksr", 2],
        "增发新股招股书刊登日": ["zfxgzgskdr", 2],
        "基金发行日": ["jjfxr", 2],
        "取消*处理日": ["qxclr", 2],
        "首发新股开始日": ["sfxgksr", 2],
        "首发新股结束日": ["sfxgjsr", 2],
        "首发新股上市日": ["sfxgssr", 2],
        "增发股权登记日": ["zfgqdjr", 2],
        "增发除权基准日": ["zfcqjzr", 2],
        "增发新股开始日": ["zfxgksr", 2],
        "增发新股结束日": ["zfxgjsr", 2],
        "配股股权登记日": ["pggqdjr", 2],
        "配股除权基准日": ["pgcqjzr", 2],
        "配股缴款开始日": ["pgjkksr", 2],
        "配股缴款结束日": ["pgjkjsr", 2],
        "配股上市日": ["pgssr", 2],
        "职工股上市日": ["zggssr", 2],
        "实行特别处理日": ["sxtbclr", 2],
        "暂停上市日": ["ztssr", 2],
        "恢复上市日": ["hfssr", 2],
        "终止上市日": ["zzssr", 2],
        "债券发行开始日": ["zqfxksr", 2],
        "债券发行结束日": ["zqfxjsr", 2],
        "债券付息登记日": ["zqfxdjr", 2],
        "基金发行结束日": ["jjfxjsr", 2],
        "基金上市日": ["jjssr", 2],
        "基金申购开始日": ["jjsgksr", 2],
        "基金赎回开始日": ["jjshksr", 2],
        "基金分红登记日": ["jjfhdjr", 2],
        "基金分红除息日": ["jjfhcxr", 2],
        "首发新股招股书刊登日": ["sfxgzgskdr", 2],
        "首发新股网上发行日": ["sfxgwsfxr", 2],
        "首发新股二级市场配售日": ["sfxgejscpsr", 2],
        "首发新股网下询价配售开始日": ["sfxgwxxjpsksr", 2],
        "增发新股网上发行日": ["zfxgwsfxr", 2],
        "增发新股网下询价配售开始日": ["zfxgwxxjpsksr", 2],
        "配股缴款日": ["pgjkr", 2],
        "债券发行日": ["zqfaxr", 2],
        "网络投票日": ["wltpr", 2],
        "对价股份上市流通日": ["djgfssltr", 2],
        "股改相关会议召开日": ["ggxghyzkr", 2],
        "摇号结果公告日": ["yhjgggr", 2],
        "中签率公告日": ["zqlggr", 2],
        "亏损将引起的暂停上市日期": ["ksjyqdztssrq", 2],
        "资产重组停牌日期": ["zccztprq", 2],
        "资产重组复牌日期": ["zcczfprq", 2],
        "最后交易日": ["zhjyr", 2],
        "暂停债转股开始日": ["ztzzgksr", 2],
        "暂停债转股结束日": ["ztzzgjsr", 2],
        "债券持有人会议召开日": ["zqcyrhyzkr", 2],
        "授予股份上市": ["sygfss", 2],
        "兑付登记日": ["dfdjr", 2],
        "债券兑付日": ["zqdfr", 2],
        "实行退市风险警示日": ["sxtsfxjsr", 2],
        "退市整理期开始日": ["tszlqksr", 2]
    };
    /*
     *获取提示
     * */
    app.getHint = function (dateStr, func, secCodes) {
        if (!app.networkState()) {
            return
        }
        secCodes = secCodes || "";
        var url = app.url.hint + "?date=" + dateStr + "&secCodes=" + secCodes;
        $.getJSON(url, function (data) {
            func(data);
        }, 'json', getJSONError, 'GET', "", false);
    };

    /*
     *获取公告
     * */
    app.getNotice = function (dateStr, type, timestamp, func, secCodes, pageNo, pageSize) {
        if (!app.networkState()) {
            return
        }
        secCodes = secCodes || "";
        pageNo = pageNo || 1;
        pageSize = pageSize || 20;
        //var url = (secCodes ? app.url.selfNotice : app.url.notice) + "?date=" + dateStr + "&stockType=" + type + "&secCodes=" + secCodes;
        // var url = (secCodes ? (app.url.selfNotice  + "?date=" + dateStr + "&secCodes=" + secCodes) : (app.url.notice + "?date=" + dateStr + "&stockType=" + type));
        var url = app.url.notice + "?date=" + dateStr + "&stockType=" + type 
        + "&secCodes=" + secCodes + "&pageNo=" + pageNo + "&pageSize=" + pageSize;
        $.getJSON(url,  function (data) {
            func(data);
        }, 'json', getJSONError, 'GET', "", false);
        /*
        {
            date: dateStr,
            stockType: type,
            secCodes: encodeURIComponent(secCodes),
            _: timestamp,
            pageNo: pageNo,
            pageSize: pageSize
        },
        */
    };

    /*
     *获取公告列表
     * */
    app.getNoticeDetail = function (dateStr, code, stockType, func) {
        if (!app.networkState()) {
            return
        }
        var url = app.url.noticeDetail + "?date=" + dateStr + "&code=" + code + "&stockType=" + stockType + "&timestamp=" + (new Date()).getTime();
        $.getJSON(url, function (data) {
            func(data);
        }, 'json', getJSONError, 'GET', "", false);
    };
})(window);

/*
 * 跟业务无关的工具
 * */
(function (g, app) {


    /*
     * 注册数据关键字改变事件
     * */
    var storageEvents = {};
    app.addStorageEvent = function (key, func) {
        storageEvents[key] = func;
    };
    window.addEventListener("storage", function (event) {
        event = event || window.event;
        if (storageEvents[event.key]) {
            storageEvents[event.key](event.newValue);
        }
    }, false);
})(window, window.app);


/*
 * 跟业务相关公用代码
 * */
(function (g, app) {

    app.setTopShow = function (val) {
        localStorage["topShowPage"] = val;
    };
    app.getTopShow = function (val) {
        var s = localStorage["topShowPage"];
        return s == undefined ? "" : s;
    };

    app.setStockType = function (i) {
        localStorage["myStockType"] = i;
    };

    //切换是否只显示自选股
    app.addStorageEvent("myStock", function (value) {
        app.getStorageMyStock(value);
    });

    //刷新页面
//    var refreshNumber = localStorage["refreshPage"] = 0;
//    app.refreshPage = function () {
//        refreshNumber += 1;
//        localStorage["refreshPage"] = refreshNumber;
//    };

    //根据自选股过滤
    app.selectByMyStock = function (list) {
        var i = 0, l = list.length, n = null, _list = [];
        for (; i < l; i += 1) {
            n = list[i];
            if (app.myStockCodeArray.indexOf(n.secCode) > -1) {
                _list.push(n);
            }
        }
        return _list;
    };

    //app缓存
    var _appCache = localStorage["appCache"];
    var appCache = _appCache ? JSON.parse(_appCache) : {};

    app.getAppCache = function (name, dateStr) {
        if (appCache[name] && appCache[name][dateStr]) {
            return appCache[name][dateStr];
        }
        return null;
    };

    app.setAppCache = function (name, dateStr, data) {
        if (!appCache[name]) {
            appCache[name] = {}
        }
        appCache[name][dateStr] = data;
        localStorage["appCache"] = JSON.stringify(appCache);
    };

    app.clearAppCache = function () {
        appCache = {};
        delete localStorage["appCache"];
    };

    app.addStorageEvent("appCache", function () {
        appCache = {};
    });

    function changeRiqi(n) {
        n = parseInt(n);
        return (n > 9 ? "" : "0") + n.toString();
    }

    app.getDateStr = function (date) {
        return date.getFullYear() + "-" + changeRiqi(date.getMonth() + 1) + "-" + changeRiqi(date.getDate())
    };
    var curDateStr = app.getDateStr(new Date()).split("-");
    app.openDatePicker = function (func) {
        uexControl.cbOpenDatePicker = function (opId, dataType, data) {
            if (dataType == 1) {
                var obj = eval('(' + data + ')');
                var d = obj.year + '-' + changeRiqi(obj.month) + '-' + changeRiqi(obj.day);
                if ((new Date(d)).getTime() - 86400000 > (new Date()).getTime()) {
                    $alert("抱歉，您选择的日期超前，还没有信息披露");
                    return;
                }
                func(d);
            }
        };
        uexControl.openDatePicker.apply(null, curDateStr);
    };

    app.getZanPer = function (zan, tu) {
        if (zan == 0 && tu == 0) {
            return 0
        }
        var l = zan + tu;
        return (zan / l) * 100 + "%";
    }
})(window, window.app);


